// This first example, maintaining tradition, prints a "Hello World" message.
// Это первый пример, традиционный, выводит "Привет мир" сообщение.
// Furthermore it shows:
// Furthermore это показывает:
//     - Using the Sample utility functions as a base for the application
//     - Использование Sample utility функций как база для приложения
//     - Adding a Text element to the graphical user interface
//     - Добавление элемента Текст на графический интерфейс пользователя
//     - Subscribing to and handling of update events
//     - Подписывание и удержание обновлений событий

#include "Scripts/Utilities/Sample.as"

void Start()
{
    // Execute the common startup for samples
    // Запускает основной запуск для примеров
    SampleStart();

    // Create "Hello World" Text
    // Создание "Привет мир" Текста
    CreateText();

    // Set the mouse mode to use in the sample
    // Установка режима мыщи используется в примере
    SampleInitMouseMode(MM_FREE);

    // Finally, hook-up this HelloWorld instance to handle update events
    // Наконец, связываем этот ПриветМир инстранцию для подхватывания обновлений событий
    SubscribeToEvents();
}

void CreateText()
{
    // Construct new Text object
    // Делаем новый Текстовый объект
    Text@ helloText = Text();

    // Set String to display
    // Назначаем Строку для вывода
    helloText.text = "Hello World from Urho3D!";

    // Set font and text color
    // Устанавливаем шрифт и цвет текста
    helloText.SetFont(cache.GetResource("Font", "Fonts/Anonymous Pro.ttf"), 30);
    helloText.color = Color(0.0f, 1.0f, 0.0f);

    // Align Text center-screen
    // Помешаем Текст в центр экрана
    helloText.horizontalAlignment = HA_CENTER;
    helloText.verticalAlignment = VA_CENTER;

    // Add Text instance to the UI root element
    // Добавляем Текстовую инстрацию на UI (интерфейс пользователя) родительного элемента
    ui.root.AddChild(helloText);
}

void SubscribeToEvents()
{
    // Subscribe HandleUpdate() function for processing update events
    // Подписываем HandleUpdate() функцию для обработки обновлений событий
    SubscribeToEvent("Update", "HandleUpdate");
}

void HandleUpdate(StringHash eventType, VariantMap& eventData)
{
    // Do nothing for now, could be extended to eg. animate the display
    // Ничего не делаем сейчас, возможно расширить это, например анимировать экран
}

// Create XML patch instructions for screen joystick layout specific to this sample app
// Создаём XML путь инструкция для экрана джойстика специфичный для примерного приложения
String patchInstructions =
        "<patch>" +
        "    <add sel=\"/element/element[./attribute[@name='Name' and @value='Hat0']]\">" +
        "        <attribute name=\"Is Visible\" value=\"false\" />" +
        "    </add>" +
        "</patch>";
